Arch Roof/pl: Difference between revisions

From FreeCAD Documentation
(Created page with "# Stwórz zamkniętą polilinię, idąc w kierunku przeciwnym do ruchu wskazówek zegara, i zaznacz ją. # Naciśnij przycisk {{Button|16px '''Dach'''}}, lub użyj skrótu klawiszowego {{KEY|R}}, a następnie {{KEY|F}}. # Domyślny obiekt dachu może mieć dziwny kształt, ponieważ narzędzie brakuje niezbędnych informacji. # Po utworzeniu domyślnego dachu, kliknij dwukrotnie na obiekt w widoku drzewa, aby uzyskać dostęp i edytować wszystkie...")
(Created page with "==Tworzenie skryptów==")
Line 88: Line 88:
* {{PropertyData|Thickness|FloatList}}: The list of thicknesses of the roof segments.
* {{PropertyData|Thickness|FloatList}}: The list of thicknesses of the roof segments.


==Scripting==
<span id="Scripting"></span>
==Tworzenie skryptów==


{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].

Revision as of 08:21, 7 April 2024

Architektura: Dach

Lokalizacja w menu
Architektura → Dach
Środowisko pracy
Architektura
Domyślny skrót
R F
Wprowadzono w wersji
-
Zobacz także
Konstrukcja, Ściana

Opis

Narzędzie Dach pozwala na utworzenie pochyłego dachu z wybranej linii. Utworzony obiekt dachu jest parametryczny, zachowując relację z obiektem bazowym. Zasada jest taka, że każdej krawędzi przypisany jest profil dachu (nachylenie, szerokość, zwis, grubość).

Uwaga: Narzędzie to jest wciąż w fazie rozwoju i może zawieść w przypadku bardzo złożonych kształtów.

Widok z góry modelu budynku przedstawiający dach z pewną przezroczystością.

Użycie

  1. Stwórz zamkniętą polilinię, idąc w kierunku przeciwnym do ruchu wskazówek zegara, i zaznacz ją.
  2. Naciśnij przycisk Dach, lub użyj skrótu klawiszowego R, a następnie F.
  3. Domyślny obiekt dachu może mieć dziwny kształt, ponieważ narzędzie brakuje niezbędnych informacji.
  4. Po utworzeniu domyślnego dachu, kliknij dwukrotnie na obiekt w widoku drzewa, aby uzyskać dostęp i edytować wszystkie właściwości. Kąt musi mieć wartość pomiędzy 0° a 90°.
  5. Każda linia odpowiada jednej płycie dachowej. Możesz więc ustawić właściwości dla każdej z nich.
  6. Aby ułatwić sobie zadanie, możesz ustawić wartość Angle lub Run na 0 i zdefiniować Relative Id, co spowoduje automatyczne obliczenie danych względem Relative Id.
  7. Działa to następująco:
    1. Jeśli Angle = 0 i Run = 0, to profil jest identyczny jak względny profil.
    2. Jeśli Angle = 0, to Angle jest obliczany tak, aby wysokość była taka sama jak w względnym profilu.
    3. Jeśli Run = 0, to Run jest obliczany tak, aby wysokość była taka sama jak w względnym profilu.
  8. W końcu, ustaw kąt na 90°, aby uzyskać szczyt.
  9. Uwaga: dla lepszego zrozumienia, zapoznaj się z prezentacją na YouTube.

Usage (solid base)

If your roof has a complex shape (e.g. contains pitched windows or other non-standard features) you can create a custom solid object using various other FreeCAD workbenches (Part, Sketcher etc.). And then use this solid as the base object for your roof:

  1. Select the solid base object.
  2. Press the Arch Roof button, or press R then F keys.

For such a custom roof the automatic subtraction volume (subvolume) is just the base object itself. If you remove this roof from your walls you will see that walls are not subtracted properly. Wall parts above the roof are not removed:

To fix this, you need to define your own subvolume. This shape can be created by extruding the bottom faces of the roof in the Z direction:

After that:

  • version 0.21 and below: Remove this shape from the walls with Arch Remove.
  • introduced in version 0.22: To override the default subvolume set the DANESubvolume property of the roof to the created shape, and remove the roof itself from the walls.

Options

Properties

Data

Roof

  • DANEAngles (FloatList): The list of angles of the roof segments.
  • DANEBorder Length (Length): The total length of the borders of the roof.
  • DANEFace (Integer): The face number of the base object used to build the roof (not used).
  • DANEFlip (Bool): Specifies if the direction of the roof should be flipped.
  • DANEHeights (FloatList): The list of calculated heights of the roof segments.
  • DANEId Rel (IntegerList): The list of IDs of the relative profiles of the roof segments.
  • DANEOverhang (FloatList): The list of overhangs of the roof segments.
  • DANERidge Length (Length): The total length of the ridges and hips of the roof.
  • DANERuns (FloatList): The list of horizontal length projections of the roof segments.
  • DANESubvolume (Link): The volume to subtract. If specified it is used instead of the auto-generated subvolume. introduced in version 0.22
  • DANEThickness (FloatList): The list of thicknesses of the roof segments.

Tworzenie skryptów

See also: Arch API and FreeCAD Scripting Basics.

The Roof tool can be used in macros and from the Python console by using the following function:

Roof = makeRoof(baseobj=None, facenr=0, angles=[45.,], run=[], idrel=[0,], thickness=[50.,], overhang=[100.,], name="Roof")
  • Creates a Roof object from the given baseobj, which can be a closed wire or a solid object.
    • If baseobj is a wire, you can provide lists for angles, run, idrel, thickness, and overhang, for each edge in the wire to define the shape of the roof.
    • The lists are automatically completed to match the number of edges in the wire.

Example:

import FreeCAD as App
import Arch, Draft

doc = App.newDocument()

rect = Draft.makeRectangle(3000, 4000)
doc.recompute()

roof = Arch.makeRoof(rect, angles=[30.,])

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(0, 2000, 0)

wire = Draft.make_wire([p1, p2, p3], closed=True)
doc.recompute()

roof1 = Arch.makeRoof(wire)

doc.recompute()